Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with maven
%bcond_with gcj_support

%if %with gcj_support
%define gcj_support 0
%else
%define gcj_support 0
%endif

%define base_name commons-attributes

Name:           jakarta-%{base_name}
Version:        2.2
Release:        alt2_3jpp5
Epoch:          0
Summary:        Commons Attributes Package
Group:          Development/Java
License:        ASL 2.0
URL:            http://jakarta.apache.org/commons/attributes
Source0:        commons-attributes-2.2-src.tar.gz
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        commons-attributes-2.2-jpp-depmap.xml
Source5:        commons-attributes-2.1-commons-build-project.xml
Source6:        commons-attributes-api-2.2.pom
Source7:        commons-attributes-compiler-2.2.pom
Source8:        commons-attributes-plugin-2.2.pom
Patch0:         commons-attributes-2.2-plugin_jelly.patch
Patch1:         commons-attributes-2.2-unittest-maven_xml.patch
Patch2:         commons-attributes-2.2-unittest-project_xml.patch
Patch3:         commons-attributes-2.2-build.patch
Requires(post): jpackage-utils >= 0:1.7.2
Requires(postun): jpackage-utils >= 0:1.7.2
Requires: ant
Requires: qdox
BuildRequires: ant >= 0:1.6
BuildRequires: ant-junit >= 0:1.6
BuildRequires: junit >= 0:3.8.1
BuildRequires: jakarta-commons-beanutils
BuildRequires: jpackage-utils >= 0:1.7.2
BuildRequires: qdox
BuildRequires: xerces-j2
BuildRequires: xml-commons-jaxp-1.3-apis
%if %with maven
BuildRequires: maven >= 0:1.1
BuildRequires: maven-plugin-xdoc
BuildRequires: saxon
BuildRequires: saxon-scripts
%endif
%if %{gcj_support}
BuildRequires: java-gcj-compat-devel
%else
BuildArch:      noarch
%endif

%description
Commons Attributes enables Java programmers to 
use C#/.Net-style attributes in their code.

%if %with maven
%package maven-plugin
Summary:        Maven plugin for %{name}
Group:          Development/Java
Requires: %{name} = %{epoch}:%{version}
Requires: maven >= 0:1.1

%description    maven-plugin
%{summary}.
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{base_name}-%{version}
mkdir commons-build
cp -p %{SOURCE5} commons-build/project.xml
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3

%build
export OPT_JAR_LIST="`%{__cat} %{_sysconfdir}/ant.d/junit`"

%if %with maven
if [ ! -f %{SOURCE4} ]; then
export DEPCAT=$(pwd)/commons-attributes-2.2-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    %{_bindir}/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
%{_bindir}/saxon $DEPCAT %{SOURCE2} > commons-attributes-2.2-depmap.new.xml
fi

for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    %{_bindir}/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done
mkdir -p .maven/repository/JPP/jars
mkdir -p .maven/plugins

export MAVEN_HOME_LOCAL=$(pwd)/.maven



mkdir -p .maven/repository/JPP/plugins/
ln -s /usr/share/java/maven-plugins/maven-xdoc-plugin.jar .maven/repository/JPP/plugins/
maven -e \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=${MAVEN_HOME_LOCAL} \
        install

cp .maven/repository/commons-attributes/jars/commons-attributes*.jar .maven/repository/JPP/jars

pushd plugin
maven -e \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=${MAVEN_HOME_LOCAL} \
        plugin:repository-install
popd

cp .maven/repository/commons-attributes/plugins/commons-attributes*.jar .maven/repository/JPP/plugins

pushd unittest
maven -e \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=${MAVEN_HOME_LOCAL} \
        -Dmaven.test.failure.ignore=true \
        attributes:test
popd

maven -e \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=${MAVEN_HOME_LOCAL} \
        site

%else
export CLASSPATH=$(build-classpath qdox)
CLASSPATH=target/classes:target/test-classes:$CLASSPATH
ant -Dbuild.sysclasspath=only dist
%endif

%install
install -dm 755 $RPM_BUILD_ROOT%{_javadir}

%if %with maven
install -pm 644 api/target/%{base_name}-api-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-api-%{version}.jar
install -pm 644 compiler/target/%{base_name}-compiler-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-compiler-%{version}.jar

# plugin
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven/repository/JPP/plugins
install -m 644 \
plugin/target/%{base_name}-plugin-%{version}.jar \
   $RPM_BUILD_ROOT%{_datadir}/maven/repository/JPP/plugins
ln -s %{base_name}-plugin-%{version}.jar \
   $RPM_BUILD_ROOT%{_datadir}/maven/repository/JPP/plugins/%{base_name}-plugin.jar

%else
install -pm 644 dist/%{base_name}-api-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-api-%{version}.jar
install -pm 644 dist/%{base_name}-compiler-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-compiler-%{version}.jar
%endif
ln -s %{name}-api-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-api.jar
ln -s %{name}-api-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{base_name}-api-%{version}.jar
ln -s %{base_name}-api-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{base_name}-api.jar
ln -s %{name}-compiler-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-compiler.jar
ln -s %{name}-compiler-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{base_name}-compiler-%{version}.jar
ln -s %{base_name}-compiler-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{base_name}-compiler.jar

%add_to_maven_depmap %{base_name} %{base_name}-api %{version} JPP %{name}-api
%add_to_maven_depmap %{base_name} %{base_name}-compiler %{version} JPP %{name}-compiler
%add_to_maven_depmap %{base_name} %{base_name}-plugin %{version} JPP/maven-plugins %{name}-plugin

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 %{SOURCE6} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-api.pom
install -pm 644 %{SOURCE7} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-compiler.pom
install -pm 644 %{SOURCE8} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-plugin.pom

# javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%if %with maven
cp -pr site/target/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%else
cp -pr dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%endif
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%files
%doc LICENSE.txt
%{_javadir}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-*%{version}.jar.*
%endif

%if %with maven
%files maven-plugin
%{_datadir}/maven/repository/JPP/plugins/*
%endif

%files javadoc
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Wed Apr 01 2009 Igor Vlasenko <viy@altlinux.ru> 0:2.2-alt2_3jpp5
- new jpp release

* Wed Nov 28 2007 Igor Vlasenko <viy@altlinux.ru> 0:2.2-alt2_1jpp1.7
- built with maven

* Fri Nov 09 2007 Igor Vlasenko <viy@altlinux.ru> 0:2.2-alt1_1jpp1.7
- updated to new jpackage release

* Tue Jul 24 2007 Igor Vlasenko <viy@altlinux.ru> 0:2.1-alt1_6jpp1.7
- converted from JPackage by jppimport script

